"""
backend URL Configuration
"""

from django.urls import path

from . import views

urlpatterns = [
    path("", views.BudgetGroupList.as_view(), name="budgetgroup_list"),
    path("group/new", views.BudgetGroupCreate.as_view(), name="budgetgroup_new"),
    path(
        "group/edit/<int:pk>",
        views.BudgetGroupUpdate.as_view(),
        name="budgetgroup_update",
    ),
    path(
        "group/delete/<int:pk>",
        views.BudgetGroupDelete.as_view(),
        name="budgetgroup_delete",
    ),
    path("line/view/<int:pk>", views.BudgetLineView.as_view(), name="budgetline_view"),
    path("line/new", views.BudgetLineCreate.as_view(), name="budgetline_new"),
    path(
        "line/edit/<int:pk>", views.BudgetLineUpdate.as_view(), name="budgetline_update"
    ),
    path(
        "line/delete/<int:pk>",
        views.BudgetLineDelete.as_view(),
        name="budgetline_delete",
    ),
]
